include(macro.m4)dnl

; as86 Macro Library
; (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1989,1995

; see info file .../doc/info/m4macros.nfo (section * as86.m4::)
dnl
dnl
dnl
;;;;; Assembly control information
define({use16},{{use16}define({i386usemode},{})})dnl
define({use32},{{use32}define({i386usemode},{d})})dnl
dnl
;;;;; Instruction set enhancement macros
dnl
define({isreg},
	{ifelse( regexp({downcase($1)},
			{^[e]?\([a-d][hlx]\|si\|di\|bp\|sp\)$}),
		0,1,0)})dnl
dnl
define({clr},{ifelse(isreg($1),{true},{xor $1,$1},{mov $1,#0})})dnl
define({setf},{ifelse(isreg($1),{true},{or $1,$1},{test $1,#-1})})dnl
define({flushinstr},{local(fi,{__nl__ jmp fi __nl__ fi: __nl__})})dnl
define({pushax},{pusha}{i386usemode})dnl
define({popax},{popa}{i386usemode})dnl
define({pushfx},{pushf}{i386usemode})dnl
define({popfx},{popf}{i386usemode})dnl
define({pushm},
   {rept({param},{$@},
	 {ifelse(regexp({param},{^[af][dx]?$}),0,{push}{param}{__nl__},
		 {push param}{__nl__})})})dnl
define({popm},{_popm(reverse($@))})dnl
define({_popm},
   {rept({param},{$@},
	 {ifelse(regexp({param},{^[af][dx]?$}),0,{pop}{param}{__nl__},
		 {pop param}{__nl__})})})dnl
dnl
;;;;; Memory allocation
define({newheap},
	{ifelse($#,1,{define({heap_$1},0)}{define({heapprefix_$1},{})},
		$#,2,{define({heap_$1},{$2})}{define({heapprefix_$1},{})},
		{define({heap_$1},{$3})}{define({heapprefix_$1},{$2+})})})dnl
define({allot},{heapprefix_$1{}varadd({heap_$1},$2)})dnl
define({_alignoffset},
	{ifelse($#,0,0,
		$#,1,0,
		$#,2,{eval(($2-1)-(($1+$2-1)%($2)))},
		{eval(($2-1)-(($1-$3+$2-1)%($2)))})})dnl
define({_aligned},{eval(_alignoffset($@)+$1)})dnl
define({alignheap},{ifelse(allot({$1},_alignoffset(heap_$@)))})dnl
define({alallot},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})dnl
dnl
;;;;; useful constants
; ASCII codes
LF	=	0x0A
CR	=	0x0D
Escape	=	0x1B
; Keyboard scancodes
K_Home	=	0x47
K_Up	=	0x48
K_PgUp	=	0x49
K_Lft	=	0x4B
K_Rgt	=	0x4D
K_EndC	=	0x4F
K_Dn	=	0x50
K_PgDn	=	0x51
K_InsC	=	0x52
K_Del	=	0x53
dnl
dnl
;;;;; negating code condition
define({ncc},
	{ifelse({$1},{po},{pe},
		{$1},{pe},{po},
		{regexp({$1},{^[n].*},{T})},{T},regexp({$1},{^.\(.*\)},{\1}),
		{n}{$1})})dnl
define({jn},
	{j{}ncc($1) shift($@)})dnl
dnl
;;;;;;;;;; Structured programming ;;;;;;;;;;
;;;;; @IF ... ( @ELSE ...) @ENDIF
dnl
define({IFNUM},0)dnl
define({@EXIT@IF},{@ELSE})dnl
define({@EXIT@ELSE},{@ELSE})dnl
define({@IF},
	{pushdef({structstk},{@IF,{$1},varincr({IFNUM})})})dnl
define({@THEN},
	{ifelse(regexp(structstk,{},.....))
	})dnl
ifelse({.....
Macro   @THEN
	Local	IFNUM,ELSENUM,IFLBL,StrucName,cc
	@POP	StrucName,STRUCSTK
	IFIDN	StrucName,<@IF>
	  @POP	cc,STRUCSTK
	  @POP	IFNUM,STRUCSTK
	  STRUCSTKPtr = STRUCSTKPtr + 1	;;; Rempiler IFNUM
	  @PUSH	STRUCSTK,<@THEN>
	  LBL	CatStr       <@ELSE>,%(IFNUM)
	  % @JN   cc, LBL ;; jmp short ?
	ELSEIFIDN StrucName,<@ELSEIF>
	ELSE
	  ERR @THEN DOES NOT MATCH @IF,@ELSE, OR @ELSEIF
	ENDIF
ENDM

Macro	@ELSE
	Local	IFNUM,ENDIFLBL,ELSELBL,StrucName
	@POP	StrucName,STRUCSTK
	ERRIFDIF	StrucName,<@THEN>
	@POP	IFNUM,STRUCSTK
	STRUCSTKPtr = STRUCSTKPtr + 1	;;; Rempiler ifnum
	@PUSH	STRUCSTK,<@ELSE>
	ELSELBL   CATSTR <@ELSE>,%(IFNUM)
	ENDIFLBL  CATSTR <@ENDIF>,%(IFNUM)
	% jmp	short ENDIFLBL
	% ELSELBL :
ENDM

Macro	@ELSEIF	cc
	Local	IFNUM,ELSENUM,ENDIFLBL,ELSELBL,StrucName
	@POP	StrucName,STRUCSTK
	ERRIFDIF	StrucName,<@THEN>
	@POP	IFNUM,STRUCSTK
	STRUCSTKPtr = STRUCSTKPtr + 1	;;; Rempiler ifnum
	@PUSH	STRUCSTK,<@ELSE>
	ELSELBL   CATSTR <@ELSE>,%(IFNUM)
	ENDIFLBL  CATSTR <@ENDIF>,%(IFNUM)
	% jmp	short ENDIFLBL
	% ELSELBL :
ENDM

Macro	@ENDIF	jmp, a,b,c,d,e,f,g,h,i,j,k,l	;;; End label may be back...
	Local	IFNUM,LBL,StrucName,ok
	@POP	STRUCname,STRUCSTK
	@POP	IFNUM,STRUCSTK
	IFIDN	STRUCname,<@THEN>
	  LBL   CATSTR <@ELSE>,IFNUM
	  % LBL :
	  ok EQU YES
	ELSEIFIDN STRUCname,<@ELSE>
	  LBL   CATSTR <@ENDIF>,IFNUM
	  % LBL :
	ELSEIFIDN STRUCname,<@ELSEIF>
	  ERR @ELSEIF NOT SUPPORTED YET.
	ELSE
	  ERR @ENDIF DOES NOT MATCH THEN, ELSE OR ELSEIF.
	ENDIF
ENDM

;;;;;;;;;;  Programmation structure : REPEAT ... UNTIL
REPEATNUM = 0
@EXIT@REPEAT	EQU  @UNTIL

Macro   @REPEAT
	Local	LBL
	@PUSH	STRUCSTK,    %(REPEATNUM)
	@PUSH	STRUCSTK,    <@REPEAT>
	LBL	CatStr       <@REPEAT>,%(REPEATNUM)
	% LBL :
	REPEAT = REPEATNUM + 1
ENDM

Macro	@UNTIL	cc
	Local	REPEATNUM,LBL,StrucName
	@POP	StrucName,STRUCSTK
	ERRIFDIF	StrucName,<@REPEAT>
	@POP	REPEATNUM,STRUCSTK
	LBL	CATSTR <@REPEAT>,%(REPEATNUM)
	@JN	cc,< short LBL >
	LBL	CATSTR <@UNTIL>,%(REPEATNUM)
	% LBL :
ENDM

;;;;;;;;;;  Programmation structure : WHILE ... DO ... WEND
WHILENUM = 0
@EXIT@WHILE	EQU  @WEND
@EXIT@DO	EQU  @WEND

Macro	@WHILE	cc
	Local	LBL
	@PUSH	STRUCSTK,    %(WHILENUM)
	@PUSH	STRUCSTK,    cc
	@PUSH	STRUCSTK,    <@WHILE>
	LBL	CatStr       <@WHILE>,%(WHILENUM)
	% LBL :
	WHILENUM = WHILENUM + 1
ENDM	@WHILE

Macro	@DO
	Local	WHILENUM,LBL,StrucName,cc
	@POP	StrucName,STRUCSTK
	ERRIFDIF	StrucName,<@WHILE>
	@POP	cc,STRUCSTK
	@POP	WHILENUM,STRUCSTK
	@PUSH	STRUCSTK,%(WHILENUM)
	@PUSH	STRUCSTK,<@DO>
	LBL	CATSTR <@WEND>,%(WHILENUM)
	% @JN	cc,short LBL
ENDM

Macro	@WEND
	Local	WHILENUM,LBL,StrucName
	@POP	StrucName,STRUCSTK
	ERRIFDIF	StrucName,<@DO>
	@POP	WHILENUM,STRUCSTK
	LBL	CATSTR <@WHILE>,%(WHILENUM)
	% jmp	LBL
	LBL	CATSTR <@WEND>,%(WHILENUM)
	% LBL :
ENDM

;;;;;;;;;;  Programmation structure : FOR ... NEXT (STEP)
IFDEF __FOR__

FORNUM = 0
@EXIT@FOR	EQU  @XFOR
@EXIT@LOOP	EQU  @XFOR

Macro	@FOR	I,Egal,I0,UpOrDownTo,I1,signed,NoPreTest
	Local	LBL,XLBL,cc
	% mov	I,I0
    ;;; trouver la condition
	% ifidni <UpOrDownTo>,<TO>
	 ifdef signed
	  cc EQU le
	 else
	  cc EQU be
	 endif
	% else
	 % errifdifi <UpOrDownTo>,<DOWNTO>
	  ifdef signed
	   cc EQU ge
	  else
	   cc EQU ae
	   % ifidni <I>,<CX>
	    if	I1 EQ 1
	      @PUSH	STRUCSTK,%(FORNUM)
	      @PUSH	STRUCSTK,<@LOOP>
	      ifndef	NoPreTest
		jcxz	XLBL
	      endif
	    endif
	   % endif
	  endif
	% endif
    ;;; Dfinitions
	LBL	CatStr	<@FOR>,%(FORNUM)
	XLBL	CatStr	<@XFOR>,%(FORNUM)
	@PUSH	STRUCSTK,I1
	@PUSH	STRUCSTK,I
	@PUSH	STRUCSTK,cc
	@PUSH	STRUCSTK,%(FORNUM)
	@PUSH	STRUCSTK,<@FOR>
    ;;; faire une boucle while !!!
	ifndef	NoPreTest
	  % cmp	I,I1
	  % @JN	cc,short XLBL
	endif
	% LBL :
	FORNUM = FORNUM + 1
ENDM

Macro	@NEXT
	Local	FORNUM,LBL,XLBL,cc,StructName,I1,I,I2
	@POP	StructName,STRUCSTK
	@POP	FORNUM,STRUCSTK
	LBL	CATSTR <@FOR>,%(FORNUM)
	XLBL	CATSTR <@XFOR>,%(FORNUM)
   ;;; Vrifier qu'il y a bien une boucle FOR
	% ifdif <StructName>,<@FOR>
	% errifdif <StructName>,<@LOOP>
	 Loop	LBL
	 % XLBL :
	 ExitM
	% endif
	@POP	cc,STRUCSTK
	@POP	I,STRUCSTK
	@POP	I1,STRUCSTK
	% ifidn	<cc>,<le>
	dec	I
	I2 = I1-1
	% endif
	% ifidn	<cc>,<be>
	dec	I
	I2 = I1-1
	% endif
	% ifidn	<cc>,<ge>
	inc	I
	I2 = I1+1
	% endif
	% ifidn	<cc>,<ae>
	inc	I
	I2 = I1+1
	% endif
	if i2
	% cmp	I,I1
	% jz	short LBL
	endif
	% XLBL :
EndM
ENDIF

;;;;;;;;;;  Programmation structure : EXIT
Macro	@EXIT	n,cc
	Local	REPET,NUM,LBL,StructName,Val
	% ifb	<cc>
	cc equ mp
	% endif
	NUM = STRUCSTKPtr
	Val EQU <StructName>
	% ifdef n
	% rept	n-1
	StkLvl	LBL,STRUCSTK,NUM
	% Val EQU LBL
	% ifdif <StructName>,<@FOR>
	NUM = NUM - 3
	% endif
	NUM = NUM - 2
	% endm
	% endif
	% LBL	CATSTR <@EXIT>,<StructName>
	LBL	CATSTR LBL,%(NUM)
	% j&cc	short LBL
EndM


;;;;;;;;;;;;;;;;;;;;;; Writing Libraries as Include files ;;;;;;;;;;;;;;;;;;;

; This is object managing at source code level. Reduces the number of
; object files (one source for any model), allows inlining, etc.


; To Do: use the STRUCSTK for this
; use markers to see if a particular procedure was already defined

; defining a macro defining a proc
Macro LibProc ProcName,MacroParams,Locals
	local MacroName
	MacroName CATSTR <def_>,ProcName
	% Macro <MacroName> <MacroParams>
	% local <Locals>
	% ifdifi <distance>,<inline>
	%   proc TestCPU distance
	% endif
EndM  LibProc

Macro EndLib whattoend
	% ifdifi <distance>,<inline>
	%    RET
    	%  EndP  TestCPU
	% endif
	% EndM <whattoend>
EndM  EndLib





;;;;;;;;;;;;;;;;;;;; Structures classiques de donnees ;;;;;;;;;;;;;;;;;;;;;;;

Struc	ListeChaineeProche
   Precedent	dd	?
   Suivant	dd	?
EndS

;;;;;;;;;;;;;;;;;;;;;;;; Exportation de donnees ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro	Export	Identifier , Type , Name
  Local StringAddress, EName
  % ifnb <Name>
      EName equ Name
  % else
      EName equ Identifier
  % endif
  Segment HeaderStrings
    StringAddress:
    %	db	!'<Name>!' , 0
  EndS
  Segment HeaderBinary
	dd	StringAddress, ID, Type
  EndS
EndM


;;;;;;;;;;;;;;;;;;;;;;;;;;;; Changing Segment ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Macro	Seg_Data
   ifdef @Model
	dataseg
   else
	Segment _Data_seg
   endif
EndM	Seg_Data
Macro	End_Data
   ifdef @Model
	codeseg	;???
   else
	EndS _Data_seg
   endif
EndM	End_Data
Macro	_Data_is dseg
   _Data_seg equ dseg
EndM	_Data_is

Macro	Seg_UData
   ifdef @Model
	udataseg
   else
	Segment _UData_seg
	;if1
   endif
EndM	Seg_UData
Macro	End_UData
   ifdef @Model
	codeseg	;?
   else
	;endif
	EndS _UData_seg
   endif
EndM	End_UData
Macro	_UData_is dseg
   _UData_seg equ dseg
EndM	_UData_is

Macro	Seg_Code
   ifdef @Model
	codeseg
   else
	Segment _Code_seg
   endif
EndM	Seg_Code
Macro	End_Code
   ifdef @Model
	dataseg
   else
	EndS _Code_seg
   endif
EndM	End_Code
Macro	_Code_is cseg
   _Code_seg equ cseg
EndM	_Code_is

;;;;;;;;;;;;;;;;;;;;;;;;; Going around the linker ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro	AddN	s1,s2,n,dest
 dest	=	s1
 	rept	n
 dest	=	dest + s2
 	endm
EndM	Add


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CONSOLE I/O ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Macro	PUTC	char
	ifnb	<char>
	  mov	al,char
	endif
	call	Putc
EndM	PUTC
Macro	GETC	mesg,savereg
	ifnb	<mesg>
	  ifnb	<savereg>
	    pusha
	  endif
	  PUTS	<mesg>
	  ifnb	<savereg>
	    popa
	  endif
	endif
	call	cGetc
EndM	GETC

define({newstring},
{
.string

Macro	lsa	dest,Message,terminator	; lsa means "Load String Address"
	local	msg,term
	ifnb <terminator>
	  term equ terminator
	else
	  term equ 0
	endif
	  Seg_Data
	   msg	db	Message
	     ifdifi <term>,<none>
		db	term
	     endif
	  End_Data
	  mov dest, offset msg
EndM	lsa
define({lsa},{


Macro	PUTS	Message
	ifidn <Message>,<CRLF>
	  call PrCRLF
	  exitm
	endif
	ifnb	<Message>
          lsa  si,<Message>
	endif
	call Puts
EndM	PUTS
Macro @PrByte mes1,val,mes2
	pusha
	ifdifi <val>,<al>
	  mov al,val
	endif
	ifnb <mes1>
	  push ax
	  PUTS <mes1>
	  pop ax
	endif
	call PutHexByte
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrByte
Macro @PrWord mes1,val,mes2
	pusha
	ifnb <mes1>
	  push val
	  PUTS <mes1>
	  pop ax
	elseifdifi <val>,<ax>
	  mov ax,val
	endif
	call PutHexWord
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrWord
Macro @PrAddr mes1,seg,ofs,mes2
	pusha
	push ofs
	push seg
	ifnb <mes1>
	  PUTS <mes1>
	endif
	pop es
	pop di
	call PutAddr
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrAddr
Macro @PrDword mes1,val,mes2
	pusha
	ifnb <mes1>
	  push val
	  PUTS <mes1>
	  pop eax
	elseifdifi <val>,<eax>
	  mov eax,val
	endif
	call PutHexDword
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrDword
Macro @PrZone mes1,seg,addr,len,mes2
	pusha
	ifdifi <seg>,<es>
	  push es
	endif
	ifnb <mes1>
	  Pushm <seg>,<addr>,<len>
	  PUTS <mes1>
	  Popm es,di,cx
	else
	  ifdifi <seg>,<es>
	    push seg
	    pop es
	  endif
	  ifdifi <addr>,<di>
	    mov di,addr
	  endif
	  ifdifi <len>,<cx>
	    mov cx,len
	  endif
	endif
	call PutZone
	ifdifi <seg>,<es>
	  pop es
	endif
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrZone
Macro @PrWZone mes1,seg,addr,len,mes2
	pusha
	ifdifi <seg>,<es>
	  push es
	endif
	ifnb <mes1>
	  Pushm <seg>,<addr>,<len>
	  PUTS <mes1>
	  Popm es,di,cx
	else
	  ifdifi <seg>,<es>
	    push seg
	    pop es
	  endif
	  ifdifi <addr>,<di>
	    mov di,addr
	  endif
	  ifdifi <len>,<cx>
	    mov cx,len
	  endif
	endif
	call PutWZone
	ifdifi <seg>,<es>
	  pop es
	endif
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrWZone
Macro @PrDZone mes1,seg,addr,len,mes2
	pusha
	ifdifi <seg>,<es>
	  push es
	endif
	ifnb <mes1>
	  Pushm <seg>,<addr>,<len>
	  PUTS <mes1>
	  Popm es,di,cx
	else
	  ifdifi <seg>,<es>
	    push seg
	    pop es
	  endif
	  ifdifi <addr>,<di>
	    mov di,addr
	  endif
	  ifdifi <len>,<cx>
	    mov cx,len
	  endif
	endif
	call PutDZone
	ifdifi <seg>,<es>
	  pop es
	endif
	ifnb <mes2>
	  PUTS <mes2>
	endif
	popa
EndM @PrDZone


;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DEBUGGING AID ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DEBUG=0

Macro %%OUT a,b,c,d,e,f,g,h,i,j,k,l
  MASM
  %OUT a b c d e f g h i j k l ;
  IDEAL
EndM

Macro @OUT@ a,b,c,d,e,f,g,h,i,j,k,l
  IF DEBUG
    %%OUT a b c d e f g h i j k l
  ENDIF
EndM
; Macro @__ ; switch in Debug Mode
; EndM
; Macro __@
; EndM
 Macro __ Message
  IF DEBUG
    pusha
    PUTS <Message>
    popa
  ENDIF
 EndM __
 Macro @_@ mesg,stop
  IF DEBUG
    ifnb <mesg>
      pusha
      PUTS <mesg>
      popa
    endif
    call DumpRegs
    ifnb <stop>
      pusha
      GETC
      popa
    endif
  ENDIF
 EndM @_@
 Macro @__@ mesg,stop
  IF DEBUG
    ifnb <mesg>
      pusha
      PUTS <mesg>
      popa
    endif
    call DumpERegs
    ifnb <stop>
      pusha
      GETC
      popa
    endif
  ENDIF
 EndM @__@
 Macro @by@ m1,v,m2
  IF DEBUG
   @PrByte <m1>,<v>,<m2>
  ENDIF
 EndM @by@
 Macro @wo@ m1,v,m2
  IF DEBUG
   @PrWord <m1>,<v>,<m2>
  ENDIF
 EndM @wo@
 Macro @addr@ m1,s,o,m2
  IF DEBUG
   @PrAddr <m1>,<s>,<o>,<m2>
  ENDIF
 EndM @addr@
 Macro @dwo@ m1,v,m2
  IF DEBUG
   @PrDword <m1>,<v>,<m2>
  ENDIF
 EndM @dwo@
 Macro @Zone@ m1,s,a,l,m2
  IF DEBUG
   @PrZone <m1>,<s>,<a>,<l>,<m2>
  ENDIF
 EndM @Zone@
 Macro @WZone@ m1,s,a,l,m2
  IF DEBUG
   @PrWZone <m1>,<s>,<a>,<l>,<m2>
  ENDIF
 EndM @WZone@
 Macro @DZone@ m1,s,a,l,m2
  IF DEBUG
   @PrDZone <m1>,<s>,<a>,<l>,<m2>
  ENDIF
 EndM @DZone@
; Macro @__
;   MASM ; could not return to IDEAL mode :-(
;   COMMENT __@
;   ;if 0 ; Once was if 0, but __@ was never expanded as endif !!!
; EndM @__
; Macro __@
;   ; endif  ;; Would never get expanded !
;   ;% endif
;   IDEAL
; EndM __@

;%%OUT End of MACRO.INC !

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Heavy debugging ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro STEP n
IF __DEBUG__
	P386
	push n
	pop gs
ENDIF
EndM  STEP
Macro STOP base,x,y,c,a
IF __DEBUG__
	P386
	mov [word base 2*x+2*80*y],c+256*a
ENDIF
EndM  STOP
Macro SST mesg
IF __DEBUG__
	GETC <mesg>
ENDIF
EndM  STOP

CRLF	equ	<13,10>
















;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;; Module de gestion de la mmoire en mode protg. ;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; voir le fichier mem386.doc pour la documentation...

; [i] Macros en mode rel
; =======================

; Contrle de la ligne A20
; ------------------------

;;;; Constantes pour accder  la ligne A20
KB_command_port	= 64h		;(en criture)
KB_status_port	= 64h		;(en lecture)
KB_data_port	= 60h
IB_free		= 2		;pour savoir si le port clavier est libre
KB_command_A20	= 0D1h		;pour accder au port de la ligne A20
set_A20_ON  = 11011111b
set_A20_OFF = 11011101b

;;;; Macros pour contrler la ligne A20

Macro	def_proc_KB_Ready  distance,erreur,nombre_essai
  local wait_IB
  ifdifi <distance>,<inline>
    Proc KB_Ready distance
  endif
 ;; Tester si le port clavier est disponible (chose ncessaire
 ;; avant de lui envoyer des commandes)
 ;; - erreur doit tre une tiquette ou se brancher si la ligne
 ;; n'est pas disponible.
 ;; - nombre_essai contient le nombre d'essais d'accs au port avant de
 ;; s'avouer vaincu.
 ;; ** dtruit AX,CX
   ifnb <&nombre_essai>
     ifdifi <nombre_essai>,<cx>
       mov cx,nombre_essai
     endif
   else
     mov cx,100
   endif
  wait_IB:
   in al,KB_status_port
   test al,IB_free
   loopne wait_IB
   jcxz erreur
  ifdifi <distance>,<inline>
	RET
    EndP  KB_Ready
  endif
EndM   def_proc_KB_Ready

Macro  set_A20	ON_OFF
 ;;  Cette macro active ou dsactive la ligne A20, en ayant test que le port
 ;; clavier est disponible.
 ;; - ON_OFF contient ON ou OFF selon que l'on veuille activer ou dsactiver
 ;; la ligne. Si ce paramtre est absent, AH doit contenir A20_ON ou A20_OFF.
 ;; - erreur doit tre une tiquette o se brancher si la ligne
 ;; n'est pas disponible.
 ;; - nombre_essai contient le nombre d'essais d'accs au port avant de
 ;; s'avouer vaincu.
 ;; ** dtruit AX
  ifnb <&ON_OFF>
    mov ah,A20_&ON_OFF
  endif
  call KB_Ready
  mov al,KB_command_A20
  out KB_command_port,al
  ;call KB_Ready	; Linus does it
  mov al,ah
  out KB_command_port,al
  ;call KB_Ready	; Linus does it
EndM  set_A20

Macro	Test_A20
   local Exit_
   ;;  Teste si la ligne A20 est active, en vrifiant si oui ou non les
   ;; adresses mmoire s'enroulent aprs la limite du mga-octet.
   ;; * Renvoie C ssi la ligne est active
   ;; ** dtruit AX
   push ds
   push es
   cli
   sub ax,ax
   mov es,ax		; es=$0000
   dec ax
   mov ds,ax		; ds=$FFFF
   mov ax,ds:[-2]	;; vrifier [$10FFEE]=[$0FFEE]
   cmp ax,es:[-18]
   stc
   jnz Exit_
   inc ds:[-2]		;; vrifier [$10FFEE]=[$0FFEE] aprs modification
   cmp ax,es:[-18]
   mov ds:[-2],ax
   stc
   jz Exit_
   clc
  Exit_:
   sti
   pop es
   pop ds
EndM Test_A20

Macro Disable_NMI
	mov al,80h
	out 70h,al
	in al,71h
EndM  Disable_NMI

Macro Enable_NMI
	mov al,00h
	out 70h,al
	in al,71h
EndM  Enable_NMI



; Le standard XMS
; ---------------

Struc	XMS_Move_Params		;; paramtres pour la fonction XMS 0Bh
   LengthToMove	dd	?
   SourceHandle	dw	?
   SourceOffset	dd	?
   DestHandle	dw	?
   DestOffset	dd	?
EndS	XMS_Move_Params


; Dterminer la nature du processeur
; ----------------------------------

Macro	def_proc_TestCPU  distance
  ifdifi <distance>,<inline>
    proc TestCPU distance
  endif

  dataseg
    NDP_STATUS dw -1
  codeseg

  ;;;; Procdure prise  Robert L. Hummel dans son bouquin sur les 80x86
  ;
  ; AH
  ; 01	8088 ou 8086
  ; 02	80286
  ; 03	80386
  ; 04	486
  ;
  ; AL
  ; 00	Pas de coprocesseur
  ; 01	8087
  ; 02	80287
  ; 03	80387
  ; 04	486DX ou 487SX
  ;
  ; Note: 0400 <=> 486SX sans copro.
  ;;;;;;
  ; dtruit tous les registres de calcul, registres copro compris.
P8086
	MOV	DX,0100H	; rponse par dfaut
	MOV	[NDP_STATUS],-1 ; non zro
  ;; sur 8088/8086, les bits 12  15 de la valeur de Flags pushe sont mis 
  ;; 1 par PUSHF; c'est pourquoi on va essayer de les effacer.
	PUSHF
	POP	AX
	AND	AH,0FH		;(effacer les bits de poids fort)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0F0H		;(les rcuprer)
	CMP	AH,0F0H
	JZ	CPUID_2		; si oui, 8086/8088
  ;; sur le 80286, au contraire, ils sont effacs
	INC	DH
	PUSHF
	POP	AX
	OR	AH,0F0H		;(mettre les bits de poids fort)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0F0H		;(les rcuprer)
	JZ	CPUID_2		; si oui, 80286
  ;; sur le 80486, le registre EFLAGS dispose d'un bit d'alignement AC.
P386
	INC	DH
	CLI
	MOV	BP,SP		; sauver SP
	AND	SP,NOT 3	; aligner SP
	PUSHFD
	POP	EAX
	MOV	EBX,EAX		; sauver EFLAGS
	XOR	EAX,00040000H	; complmenter AC
	PUSH	EAX
	POPFD
	PUSHFD
	POP	EAX
	PUSH	EBX
	POPFD			; restaurer AC
	MOV	SP,BP		; restaurer la pile
	XOR	EAX,EBX		; regarder si AC a t modifi
	STI
	JZ	CPUID_2		; c'est un 386
	INC	DH
  ;;;; Maintenant, tester le coprocesseur:
CPUID_2:
	FNINIT				;rinitialiser le mot d'tat
	FNSTSW	[NDP_STATUS]
	CMP	[Byte ptr NDP_STATUS],0	;si non nul, pas de copro
	JNZ	CPUID_3
	FNSTCW	[NDP_STATUS]		;tenter d'crire un mot de contrle
	AND	[NDP_STATUS],103FH
	CMP	[NDP_STATUS],3FH
	JNZ	CPUID_3
  ;;;; le seul cas o le copro peut ne pas correspondre, c'est quand un
  ;;;; 80287 est avec un 80386
	MOV	DL,DH			;initialiser le type de NDP
	CMP	DH,3			;pas 386 => ok
	JNZ	CPUID_3
  ;;; 387/287: le NDP (initialis) doit grer les infinis. Mais le 287 les
  ;;; confond.
	FLD1
	FLDZ
	FDIV
	FLD	ST
	FCHS
	FCOMPP
	FSTSW	[NDP_STATUS]
	MOV	AX,[NDP_STATUS]
	SAHF
	JNZ	CPUID_3			;diffrend:387
	DEC	DL
CPUID_3:
	MOV	AX,DX
  ifdifi <distance>,<inline>
	RET
    EndP  TestCPU
  endif
EndM	def_proc_TestCPU



; Gestion de la mmoire en mode protg
; =====================================

Macro	DefDescriptor	bas,Lim,_P_DPL_DT_Type,_G_D_0_AVL
    dw  (Lim) and 0FFFFh
    dw	(bas) and 0FFFFh
    db	( (bas) shr 16 ) and 0FFh
    db	_P_DPL_DT_Type
    db	(_G_D_0_AVL) shl 4 + ( ( (Lim) shr 16) and 0Fh )
    db	(bas) shr 24
EndM

Macro	DefPorte	sel,ofs,compteur,_P_DPL_DT_Type
    dw  (ofs) and 0FFFFh
    dw	sel
    db	compteur
    db	_P_DPL_DT_Type
    dw (ofs) shr 16
EndM

Macro	SetDescriptor	DESCRIPT
   ;;; Cette macro initialise un descripteur avec
   ;;; - DESCRIPT contenant la chane adresse du descripteur
   ;;; - ebx pour adresse de base
   ;;; - ecx pour champ limite
   ;;; - al pour les champs d'information: P,DPL,DT,Type
   ;;; - ah pour G,D,AVL
   ;;; * dtruit eax,ebx,ecx
   mov [DESCRIPT],cx
   shr ecx,16
   mov [DESCRIPT+2],bx
   shr ebx,16
   or cl,ah
   mov ch,bh
   mov bh,al
   mov [DESCRIPT+4],bx
   mov [DESCRIPT+6],cx
EndM

Macro	GetDescriptor	DESCRIPT
   Local
   ;;; Cette macro fait le contraire de la prcdente:
   ;;; - DESCRIPT contient la chane adresse du descripteur
   ;;; - ebx pour adresse de base
   ;;; - ecx pour champ limite
   ;;; - al pour les champs d'information: P,DPL,DT,Type
   ;;; - ah pour G,D,AVL
   mov cx,DESCRIPT[6]
   mov bx,DESCRIPT[4]
   mov al,bh
   mov bh,ch
   mov ah,cl
   and cx,0Fh
   shl ebx,16
   mov bx,DESCRIPT[2]
   shl ecx,16
   mov cx,DESCRIPT
EndM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; TSS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Struc	pushad_s
	irp   parm,<edi,esi,ebp,esp,ebx,edx,ecx,eax>
          pushad_&parm  dd  ?
	endm
EndS	pushad_s
Struc	pusha_s
	irp   parm,<di,si,bp,sp,bx,dx,cx,ax>
          pusha_&parm  dw  ?
	endm
EndS	pusha_s

Struc	TSS16
;;;; spcifications Intel
    Sel_Lien_Arriere dw ?
    SP_CPL0	dw	? ; not updated by task switching
    SS_CPL0	dw	? ;
    SP_CPL1	dw	? ;
    SS_CPL1	dw	? ;
    SP_CPL2	dw	? ;
    SS_CPL2	dw	? ;
    saveIP	dw	?
    saveFlags	dw	?
    saveAX	dw	?
    saveCX	dw	?
    saveDX	dw	?
    saveBX	dw	?
    saveSP	dw	?
    saveBP	dw	?
    saveSI	dw	?
    saveDI	dw	?
    saveES	dw	?
    saveCS	dw	?
    saveSS	dw	?
    saveDS	dw	?
    saveLDT	dw	? ; not updated by task switching
EndS

Struc	TSS32
;;;; spcifications Intel
    Sel_Lien_Arriere dw ?,0	;(???)
    ESP_CPL0	dd	?	; not updated by task switching
    SS_CPL0	dw	?,0	;
    ESP_CPL1	dd	?	;
    SS_CPL1	dw	?,0	;
    ESP_CPL2	dd	?	;
    SS_CPL2	dw	?,0	;
		dd	0	;(reserved)
    saveEIP	dd	?
    saveEFlags	dd	?
    saveEAX	dd	?
    saveECX	dd	?
    saveEDX	dd	?
    saveEBX	dd	?
    saveESP	dd	?
    saveEBP	dd	?
    saveESI	dd	?
    saveEDI	dd	?
    saveES	dw	?,0	; 0's not updated by task switching
    saveCS	dw	?,0
    saveSS	dw	?,0
    saveDS	dw	?,0
    saveFS	dw	?,0
    saveGS	dw	?,0
    saveLDT	dw	?,0	; not updated by task switching
    TrapBit	dw	0	; not updated by task switching
    IO_Map_Base	dw	?	; not updated by task switching
EndS

PAGESIZE = 4096
PAGEBITS = 12
})